// Program: Lesson 15, Exercise 3

// NOTE: we present two different implementations of expt:
//   (1) expt_rec -- a recursive implementation
//   (2) expt_itr -- an iterative implementation

#include <iostream.h>

float sqr(float x) { return x * x; }

float expt_rec(float x, unsigned int n = 1)
// this implementation of expt is recursive,
// and takes (about) log(n) steps to complete
{
    if (n == 0)
      return 1;
    else
      if ((n % 2) == 0)  // n is even
	return sqr(expt_rec(x, n/2));
      else
	return x * expt_rec(x, n-1);
}

// OR, ALTERNATIVELY:

float expt_itr(float x, unsigned int n = 1)
// this implementation of expt is itertarive,
// and takes (about) n steps to complete
{
    float result = 1;

    for ( ; n >= 1; --n)
       result *= x;

    return result;
}

void main(void)
 {
    cout << expt_rec (3,3) << endl;
    cout << expt_rec (1,15) << endl;
    cout << expt_rec (7) << endl;
    cout << expt_rec (-4.3,7) << endl;

    cout << expt_itr (3,3) << endl;
    cout << expt_itr (1,15) << endl;
    cout << expt_itr (7) << endl;
    cout << expt_itr (-4.3,7) << endl;
 }


